#include <Arduino.h>

const int greenPin = 4;
const int alert_pin = 3;
const int redPin = 5;
const int buzzer = 9;
const int Y = 0;
const int X = 1;
const int SEL = 2;
int vert, horiz, select;
int cur_move = 0;
int password[] = {2,-1,1,2,-2,-1};
int const pswd_length = 6;
// -1 = left, 1 = right, -2 = down, 2 = up
int has_reset = 0;

int moves[pswd_length] = {0,0,0,0,0,0};
int place = 0;

int activate = 0;
int push_reset = 0;
volatile byte state = LOW;
int correct = 0;

bool systemState = false;

int alert = 0;

void error(const __FlashStringHelper*err) {
  Serial.println(err);
  while (1);
}
void setup() {
  pinMode(greenPin, OUTPUT);
  pinMode(redPin, OUTPUT);
  pinMode(alert_pin, OUTPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(SEL, INPUT_PULLUP);
  Serial.begin(115200);
  Serial.setTimeout(1);
  attachInterrupt(digitalPinToInterrupt(SEL), blink, FALLING);

}

void blink(){
  state = !state;
}

int check_password(){
  if ((sizeof(moves) / sizeof(int)) < pswd_length){
    return 0;
  }
  for (int i = 0; i < pswd_length; i++){
    if (password[i] != moves[i]){
      return 0;
    }
  }
  return 1;
}

void loop() {
  if (systemState == true) {
    digitalWrite(greenPin, HIGH);
    digitalWrite(redPin, LOW);
    delay(1000);
    noTone(buzzer);
    delay(1000);
  } else {
    digitalWrite(redPin, HIGH);
    digitalWrite(greenPin, LOW);
    tone(buzzer,1000);
  }

  vert = analogRead(Y);
  horiz = analogRead(X);
  select = digitalRead(SEL);
  
  if (select == HIGH){
    
  }
  cur_move = 0;
  if (push_reset == 0){
    if (select != HIGH){
      // button was just pushed to activate password mode
      if(activate == 0){
        Serial.println("Password Started");
        activate = 1;
        push_reset = 1;
        place = 0;
      }
      // button was pushed to confirm password
      else {
        Serial.println("Password Confirmed");
        activate = 0;
        push_reset = 1;
        place = 0;
        correct = check_password();
        if (correct == 1){
          Serial.println("password is correct");
          systemState = true;
          moves[pswd_length] = {0};
        }
        else{
          Serial.println("password is incorrect");
        }
      }
    }
  }
  // if select = 0, then the push button has reset
  else if (select == HIGH){
    push_reset = 0;
  }
  
  if(has_reset == 1){
    if (vert > 255 && vert <767 && horiz <767 && horiz > 255){
      has_reset = 0;
      Serial.println("Reset"); 
    }
  }
  else{
    if (vert > 767 && horiz > 255 && horiz <767){
      cur_move = 2;
      has_reset = 1;
      Serial.println("UP"); 
    }
    else if (vert < 255 && horiz > 255 && horiz <767){
      cur_move = -2;
      has_reset = 1;
      Serial.println("Down"); 
    }
    else if (horiz > 767 && vert > 255 && vert <767){
      cur_move = 1;
      has_reset = 1; 
      Serial.println("Right"); 
    }
    else if (horiz < 255 && vert > 255 && vert <767){
      cur_move = -1;
      has_reset = 1; 
      Serial.println("Left");
    }
    if (cur_move != 0){
      moves[place] = cur_move;
      place = place + 1;
    }
    if (place >= pswd_length){
      place = 0;
    }
    
  }
  
  if (select == HIGH){
    //Serial.println("Not Pressed");
  }
  else{
    Serial.println("Pressed");
  }
}
